<%
require "xmlrpc/server"
class ASPServer < XMLRPC::BasicServer
  @@obj = nil

  def ASPServer.new( *a )
    @@obj = super( *a ) if @@obj.nil?
    @@obj
  end

  def initialize( *a )
    super( *a )
  end

  def serve( data )
    process(data)
  end
  
end

s = ASPServer.new

s.add_handler("sample.sumAndDifference") do |a,b|
  { "sum" => a + b, "difference" => a - b }
end

# $Response.appendToLog( $Request.query )
begin
  $Response.contentType = "text/xml"
  # $Response.charset = ""
  print s.serve( $Request.query )
rescue
  $Response.contentType = "text/html"
  $Response.include( "header.inc" ) 
%>

<h2>Demo: xmlrpc_server.asp</h2>
XML-RPC server using <a href="http://www.ntecs.de/projects/xmlrpc4r/">xmlrpc4r</a>. You can try it with <a href="source.asp?file=xmlrpc_client.txt">this</a> script.
 
<%
  $Response.include( "footer.inc" )
end
%>
